<?php

class BaseController extends Controller
{
	//persistent GET parameters keeping in the urls
	private $persistentUrlParams = array('modelLevel','modelClass','modelPk','modelRelationName','modelRelationClass','relatedModelClass');
	

	public function init() {
/*
		//loading module resources
		$cs = Yii::app()->getClientScript();
		$moduleAssetsPath =
			Yii::app()->getAssetManager()->publish( Yii::getPathOfAlias( $this->getModule()->getId() . '.assets'), false, -1, @Yii::app()->params['dev'] );

		//Linking asset files
		//$cs->registerCssFile( $moduleAssetsPath . '/css/xcruder.css');
		$cs->registerScriptFile( $moduleAssetsPath . '/js/controllers/' . $this->getId() . '.js');
*/
	}
	
	
	public static function GET($key) {
		return !$key || !isset($_GET[$key]) ? '' : $_GET[$key];
	}
	
/**
 * Extends the param array from the GET request by the persistent URL params
 **/
	private function extendParams($params, $decodePk = false) {
		if (!$params)
			$params = array();
		
		foreach($this->persistentUrlParams as $key)
			if ( !isset($params[$key]) && isset($_GET[$key]) )
				$params[$key] = $_GET[$key];
		
		if ($decodePk && isset($params['modelPk'])) {
			$params['pk'] = @CJSON::decode($params['modelPk'], true);
		}
			
		return $params;
	}
	
/**
 * Forwarding persistent request params
 **/
	public function createUrl($route, $params = array(), $ampersand='&') {
		
		return parent::createUrl($route, $this->extendParams($params), $ampersand);

	}
	public function renderPartial($view, $data=NULL, $return=false, $processOutput=false) {

		return parent::renderPartial($view, $this->extendParams($data, true), $return, $processOutput);

	}
	




/**
 * Basic access control for XCRUD
*/

	public function filters()
	{
		return array(
			'accessControl' // perform access control for CRUD operations
		);
	}

/*
http://www.yiiframework.com/doc/guide/1.1/en/topics.auth

	*: any user, including both anonymous and authenticated users.
	?: anonymous users.
	@: authenticated users.

The first matching rule will be applied.
*/
	public function accessRules() {

		return array(
				array('allow',
					'users'=>array('@')
				),
				array('deny',
					'users'=>array('*')
				)
		);

	}

}
